from socket import socket, AF_INET, SOCK_STREAM,SOL_SOCKET,SO_REUSEADDR
from threading import Thread
import TCPp2p.TCPReceiverHandler


class TCPDefaultHandler(TCPp2p.TCPReceiverHandler.TCPReceiverHandler):

    def Handle(self, message):
        str=""
        for data in message:
            str=str+data.decode("utf-8")

        print(str)


class TCPReceiverThread(Thread):

    def __init__(self, port=5555, buffer=1024, handler=TCPDefaultHandler()):
        super(TCPReceiverThread, self).__init__()
        self.stopped = False
        self.port = port
        self.buffer = buffer
        self.socketserver = socket(AF_INET, SOCK_STREAM)
        self.socketserver.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
        self.socketserver.bind(("", self.port))
        self.tcphandlers = {handler}

    def run(self):
        while not self.stopped:
            self.socketserver.listen()
            fulldata=[]
            conn, addr = self.socketserver.accept()
            while 1:
                data=conn.recv(self.buffer)
                if not data:
                    break
                else:
                    fulldata.append(data)

            for handler in self.tcphandlers:
                handler.Handle(fulldata)

        self.socketserver.close()

    def stop(self):
        self.stopped=True

    def addlistener(self, handler):
        self.tcphandlers.add(handler)

