from socket import socket, AF_INET, SOCK_STREAM
import TCPp2p.TCPp2pUtilities



class TCPTransmitter:
    """Simple TCP transmitter, working in two different way:

            -Continued_mode:
            -Non_Continued_mode:

    """
    def __init__(self, continued=False, ip=TCPp2p.TCPp2pUtilities.getlocalip(), port=5555):
        self.socket = socket(AF_INET, SOCK_STREAM)
        self.continued=continued
        self.ip = ip
        self.port = port
        if self.continued:
            self.socket.connect((self.ip, self.port))

    def sendMessage(self, message, ip, port):
        """Send given message to given ip:port, closing TCP socket after message sending's end"""
        self.socket.connect((ip, port))
        self.socket.send(message.encode())
        self.socket.close()

    def sendMessageContinued(self,message):
        print("Sending"+str(message))
        tmp=str(message)
        self.socket.send(tmp.encode())

    def closeContinued(self):
        self.socket.close()

T=TCPTransmitter()
T.sendMessage("buu","127.0.0.1",5555)